﻿'Menu991    Menu save and restore program fro FT-991
'Author     H.NAMVA JH4ADK
'Original issued on 2017.01.30
Public Class Form1
    Private Sub btnCONN_Click(sender As Object, e As EventArgs) Handles btnCONN.Click
        If COMport.IsOpen Then
            COMport.Close()
            btnCONN.Text = "CONN"
            btnCONN.BackColor = SystemColors.Control
            Panel2.Enabled = False

        Else
            Try
                COMport.PortName = tbCOM.Text
                COMport.BaudRate = Integer.Parse(cbBPS.Text)
                COMport.NewLine = ";"
                COMport.ReadTimeout = 1000
                COMport.Open()
                btnCONN.Text = "DISC"
                btnCONN.BackColor = Color.YellowGreen
                Panel2.Enabled = True
            Catch ex As Exception
                MsgBox("COMポートのオープンに失敗しました" & vbCrLf & ex.Message)
            End Try
        End If

    End Sub

    Private Sub SendPortStr(ByRef str As String)
        COMport.Write(str, 0, str.Length)
    End Sub

    Private Sub btnSave_Click(sender As Object, e As EventArgs) Handles btnSave.Click
        If SaveFileDialog1.ShowDialog() = DialogResult.OK Then
            Dim enc As System.Text.Encoding = System.Text.Encoding.GetEncoding("Shift_JIS")
            Dim strm As New System.IO.StreamWriter(SaveFileDialog1.FileName, False, enc)
            Dim i As Integer
            Dim resp As String
            Dim menuMax As Integer
            If rb991.Checked Then
                menuMax = 151
            Else
                menuMax = 154
            End If
            For i = 1 To menuMax
                SendPortStr("EX" & i.ToString("D3") & ";")
                resp = COMport.ReadLine & ";"
                'Debug.Print(resp)
                strm.Write(resp & vbCrLf)
            Next
            strm.Close()
            MsgBox("メニューをファイルに記録しました")
        End If
    End Sub

    Private Sub btnRestore_Click(sender As Object, e As EventArgs) Handles btnRestore.Click
        If OpenFileDialog1.ShowDialog() = DialogResult.OK Then
            Dim enc As System.Text.Encoding = System.Text.Encoding.GetEncoding("Shift_JIS")
            Dim strm As New System.IO.StreamReader(OpenFileDialog1.FileName, enc, False)
            Try
                Do
                    Dim str As String = strm.ReadLine
                    SendPortStr(str)
                    'Debug.Print("Send:" & str)
                    Threading.Thread.Sleep(20)
                Loop Until strm.EndOfStream
                strm.Close()
                MsgBox("ファイルからメニューを復元しました")
            Catch ex As Exception
                MsgBox("途中でエラーが発生しました" & vbCrLf & ex.Message)
            End Try

        End If
    End Sub
End Class
